<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/date_time_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>:Info: date_time_:  1991-01-03 date_time_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The date_time_ system is a utility which encodes, decodes, adjusts, or
<span id="L4" class="LineNr">  4 </span>formats a Multics standard calendar clock value.  The clock reading is
<span id="L5" class="LineNr">  5 </span>assumed to be in microseconds relative to 1901-01-01 0:00 gmt.  The
<span id="L6" class="LineNr">  6 </span>ASCII times involved may be one of several languages and in a choice of
<span id="L7" class="LineNr">  7 </span>time zones around the world.
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>Entry points in date_time_:
<span id="L11" class="LineNr"> 11 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>:Entry:  date_time_:  1985-03-04 date_time_
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>Function:  The date_time_ subroutine converts a system clock value to
<span id="L18" class="LineNr"> 18 </span>ASCII representation.  It will be in terms of the process default
<span id="L19" class="LineNr"> 19 </span>language and zone.
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>Syntax:
<span id="L23" class="LineNr"> 23 </span>declare date_time_ entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L24" class="LineNr"> 24 </span>call date_time_ <span class="textRainbow_lv0_p0">(</span>clock<span class="textRainbow_lv0_o0">,</span> str<span class="textRainbow_lv0_p0">)</span>;
<span id="L25" class="LineNr"> 25 </span>
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>Arguments:
<span id="L28" class="LineNr"> 28 </span>clock
<span id="L29" class="LineNr"> 29 </span>   is the clock value to be formatted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L30" class="LineNr"> 30 </span>str
<span id="L31" class="LineNr"> 31 </span>   is the resultant character string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L32" class="LineNr"> 32 </span>
<span id="L33" class="LineNr"> 33 </span>
<span id="L34" class="LineNr"> 34 </span>Notes:  The format string which produces the resultant string is:
<span id="L35" class="LineNr"> 35 </span>       &quot;^my/^dm/^yc  ^Hd^99v.9MH ^xxxxza^xxxxda&quot;
<span id="L36" class="LineNr"> 36 </span>which produces strings like this:
<span id="L37" class="LineNr"> 37 </span>       mm/dd/yy  HHMM.M zzzddd
<span id="L38" class="LineNr"> 38 </span>       07/14/83  1435.4 mst Thu
<span id="L39" class="LineNr"> 39 </span>See time_strings.gi for a description of acceptable strings.
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>The ASCII representation of time, which date_time_ attempts to return
<span id="L42" class="LineNr"> 42 </span>in string, is 24 characters long.  If string is declared by the caller
<span id="L43" class="LineNr"> 43 </span>with a length of N and N is less than 24, then only the first N
<span id="L44" class="LineNr"> 44 </span>characters are returned.  If N is greater than 24, then the result is
<span id="L45" class="LineNr"> 45 </span>returned padded on the right with spaces.
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>If clock is not a valid date, &quot;01/01/01 0000.0 gmt Tue&quot; is returned.
<span id="L48" class="LineNr"> 48 </span>
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>:Entry:  format:  1985-03-04 date_time_$format
<span id="L51" class="LineNr"> 51 </span>
<span id="L52" class="LineNr"> 52 </span>
<span id="L53" class="LineNr"> 53 </span>Function:  This entry does a generalized formatting of a Multics
<span id="L54" class="LineNr"> 54 </span>standard calendar clock value.  A format string is supplied which
<span id="L55" class="LineNr"> 55 </span>describes the layout and content of the desired result.  The zone
<span id="L56" class="LineNr"> 56 </span>and/or language in which the result is to be displayed may be
<span id="L57" class="LineNr"> 57 </span>specified.
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>
<span id="L60" class="LineNr"> 60 </span>Syntax:
<span id="L61" class="LineNr"> 61 </span>declare date_time_$format entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L62" class="LineNr"> 62 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span> returns <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>250<span class="textRainbow_lv1_p0">)</span> var<span class="textRainbow_lv0_p0">)</span>;
<span id="L63" class="LineNr"> 63 </span>result = date_time_$format <span class="textRainbow_lv0_p0">(</span>time_format<span class="textRainbow_lv0_o0">,</span> clock<span class="textRainbow_lv0_o0">,</span> zone<span class="textRainbow_lv0_o0">,</span> lang<span class="textRainbow_lv0_p0">)</span>;
<span id="L64" class="LineNr"> 64 </span>
<span id="L65" class="LineNr"> 65 </span>
<span id="L66" class="LineNr"> 66 </span>Arguments:
<span id="L67" class="LineNr"> 67 </span>time_format
<span id="L68" class="LineNr"> 68 </span>   either a keyword, or an ioa-like control string describing the
<span id="L69" class="LineNr"> 69 </span>   desired result in terms of literal characters and date/time
<span id="L70" class="LineNr"> 70 </span>   selectors.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> See time_format.gi.info for details.
<span id="L71" class="LineNr"> 71 </span>clock
<span id="L72" class="LineNr"> 72 </span>   a clock value to be displayed.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L73" class="LineNr"> 73 </span>zone
<span id="L74" class="LineNr"> 74 </span>   the short name of the zone in which output time value is expressed.
<span id="L75" class="LineNr"> 75 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> &quot;system_zone&quot; means use the system default zone.  &quot;&quot; means
<span id="L76" class="LineNr"> 76 </span>   use the per-process default zone.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L77" class="LineNr"> 77 </span>lang
<span id="L78" class="LineNr"> 78 </span>   the language in which month names, day names and time zones are
<span id="L79" class="LineNr"> 79 </span>   expressed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> &quot;system_lang&quot; means use the system default time
<span id="L80" class="LineNr"> 80 </span>   language.  &quot;&quot; means use per-process default time language.
<span id="L81" class="LineNr"> 81 </span>
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>result
<span id="L84" class="LineNr"> 84 </span>   is the string which is the result of the conversion.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L85" class="LineNr"> 85 </span>
<span id="L86" class="LineNr"> 86 </span>
<span id="L87" class="LineNr"> 87 </span>Notes on time format:
<span id="L88" class="LineNr"> 88 </span>The control string to date_time_$format is either a keyword or a
<span id="L89" class="LineNr"> 89 </span>character string consisting of text and/or selectors.  The selectors
<span id="L90" class="LineNr"> 90 </span>are identified by a leading circumflex character <span class="textRainbow_lv0_p0">(</span>^<span class="textRainbow_lv0_p0">)</span>.  There are 2
<span id="L91" class="LineNr"> 91 </span>types of selectors:
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>  ^&lt;keyword&gt;  allows a keyword to be imbedded within a format.
<span id="L94" class="LineNr"> 94 </span>  ^XX         a 2 letter code identifying the wanted information.
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>An optional PL/I picture specification may be placed between the ^ and
<span id="L97" class="LineNr"> 97 </span>XX if the default form is not adequate.
<span id="L98" class="LineNr"> 98 </span>
<span id="L99" class="LineNr"> 99 </span>
<span id="L100" class="LineNr">100 </span>If the control string does not contain any circumflex characters, it
<span id="L101" class="LineNr">101 </span>must then be one of the known set of keywords.  Each keyword
<span id="L102" class="LineNr">102 </span>identifies a control string for a predetermined format named by that
<span id="L103" class="LineNr">103 </span>keyword.
<span id="L104" class="LineNr">104 </span>
<span id="L105" class="LineNr">105 </span>For information about ^XX selectors, type:
<span id="L106" class="LineNr">106 </span>   help time_format.gi -scn selectors
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span>
<span id="L109" class="LineNr">109 </span>List of format keywords:
<span id="L110" class="LineNr">110 </span>all
<span id="L111" class="LineNr">111 </span>   ^9999yc-^my-^dm__^Hd:^MH:^99.<span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span>9UM^zd_^za_^da ^fi
<span id="L112" class="LineNr">112 </span>   ^<span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span>9fw ^ma dy^dy dc^dc Uc^Uc
<span id="L113" class="LineNr">113 </span>calendar_clock
<span id="L114" class="LineNr">114 </span>   ^9999yc-^my-^dm__^Hd:^MH:^99.<span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span>9UM_^za_^da
<span id="L115" class="LineNr">115 </span>clock
<span id="L116" class="LineNr">116 </span>   ^9999yc-^my-^dm ^Hd:^MH:^99.<span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span>9UM ^za ^da
<span id="L117" class="LineNr">117 </span>date
<span id="L118" class="LineNr">118 </span>   the process default value for date
<span id="L119" class="LineNr">119 </span>date_time
<span id="L120" class="LineNr">120 </span>   the process default value for date and time
<span id="L121" class="LineNr">121 </span>iso_date
<span id="L122" class="LineNr">122 </span>   ^9999yc-^my-^dm
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>iso_date_time
<span id="L126" class="LineNr">126 </span>   ^9999yc-^my-^dm ^Hd:^MH:^SM ^za
<span id="L127" class="LineNr">127 </span>iso_long_date
<span id="L128" class="LineNr">128 </span>   ^9999yc-^my-^dm ^da
<span id="L129" class="LineNr">129 </span>iso_long_date_time
<span id="L130" class="LineNr">130 </span>   ^9999yc-^my-^dm ^Hd:^MH:^99.<span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span>9UM ^za
<span id="L131" class="LineNr">131 </span>iso_long_time
<span id="L132" class="LineNr">132 </span>   ^Hd:^MH:^99.<span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span>9UM
<span id="L133" class="LineNr">133 </span>iso_time
<span id="L134" class="LineNr">134 </span>   ^Hd:^MH:^SM
<span id="L135" class="LineNr">135 </span>multics_date
<span id="L136" class="LineNr">136 </span>   ^my/^dm/^yc
<span id="L137" class="LineNr">137 </span>multics_date_time
<span id="L138" class="LineNr">138 </span>   ^my/^dm/^yc ^Hd^99v.9MH ^xxxxza^xxxda
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>multics_time
<span id="L142" class="LineNr">142 </span>   ^Hd:^MH
<span id="L143" class="LineNr">143 </span>request_id
<span id="L144" class="LineNr">144 </span>   ^yc^my^dm^Hd^MH^99.<span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span>9UM
<span id="L145" class="LineNr">145 </span>system_date_time
<span id="L146" class="LineNr">146 </span>   the system default value for date and time
<span id="L147" class="LineNr">147 </span>system_date
<span id="L148" class="LineNr">148 </span>   the system default value for date
<span id="L149" class="LineNr">149 </span>system_time
<span id="L150" class="LineNr">150 </span>   the system default value for time
<span id="L151" class="LineNr">151 </span>time
<span id="L152" class="LineNr">152 </span>   the process default value for time
<span id="L153" class="LineNr">153 </span>
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>   A site may change the &quot;system&quot; keywords.  To list the &quot;system&quot;
<span id="L156" class="LineNr">156 </span>   keywords for your site, type:
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>      print_time_defaults -system
<span id="L159" class="LineNr">159 </span>
<span id="L160" class="LineNr">160 </span>   For an application which depends upon the historic date/time
<span id="L161" class="LineNr">161 </span>   formats, the 3 builtin &quot;multics&quot; keywords are available.
<span id="L162" class="LineNr">162 </span>
<span id="L163" class="LineNr">163 </span>
<span id="L164" class="LineNr">164 </span>:Entry:  format_max_length:  1985-03-04 date_time_$format_max_length
<span id="L165" class="LineNr">165 </span>
<span id="L166" class="LineNr">166 </span>
<span id="L167" class="LineNr">167 </span>Function:  This entry returns the length of the longest result which a
<span id="L168" class="LineNr">168 </span>format can generate.  The zone and/or language in which to work may be
<span id="L169" class="LineNr">169 </span>specified.
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>Syntax:
<span id="L173" class="LineNr">173 </span>declare date time_$format_max_length entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L174" class="LineNr">174 </span>     returns <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>;
<span id="L175" class="LineNr">175 </span>max_len = date_time_$format_max_length <span class="textRainbow_lv0_p0">(</span>format<span class="textRainbow_lv0_o0">,</span> zone<span class="textRainbow_lv0_o0">,</span> lang<span class="textRainbow_lv0_p0">)</span>;
<span id="L176" class="LineNr">176 </span>
<span id="L177" class="LineNr">177 </span>
<span id="L178" class="LineNr">178 </span>Arguments:
<span id="L179" class="LineNr">179 </span>format
<span id="L180" class="LineNr">180 </span>   a control string intended to be given to date_time_$format.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L181" class="LineNr">181 </span>   b..argx zone the short name of the zone in which conversion will be
<span id="L182" class="LineNr">182 </span>   done.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> &quot;system_zone&quot; means use the system default zone.  &quot;&quot;
<span id="L183" class="LineNr">183 </span>   means use the per-process default zone.  <span class="textRainbow_lv0_p0">(</span>input<span class="textRainbow_lv0_p0">)</span>
<span id="L184" class="LineNr">184 </span>lang
<span id="L185" class="LineNr">185 </span>   the language in which month names and time zones are expressed.
<span id="L186" class="LineNr">186 </span>   &quot;system_lang&quot; means use the system default time language.  &quot;&quot; means
<span id="L187" class="LineNr">187 </span>   use per-process default time language.
<span id="L188" class="LineNr">188 </span>max_len
<span id="L189" class="LineNr">189 </span>   is the length of the longest string which can result from processing
<span id="L190" class="LineNr">190 </span>   the given format.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L191" class="LineNr">191 </span>
<span id="L192" class="LineNr">192 </span>
<span id="L193" class="LineNr">193 </span>:Entry:  from_clock:  1985-03-04 date_time_$from_clock
<span id="L194" class="LineNr">194 </span>
<span id="L195" class="LineNr">195 </span>
<span id="L196" class="LineNr">196 </span>Function:  Given a Multics standard calendar clock value and an output
<span id="L197" class="LineNr">197 </span>time zone name, return the month, day of the month, the year, the hour
<span id="L198" class="LineNr">198 </span>of the day, the minute of the hour, the second of the minute, the
<span id="L199" class="LineNr">199 </span>number of microseconds, the day in week, the day in year, and the day
<span id="L200" class="LineNr">200 </span>in clock.  The caller may specify one of the time zones in the
<span id="L201" class="LineNr">201 </span>time_info_ in which the decoded clock value is to be expressed, or may
<span id="L202" class="LineNr">202 </span>request that the value be expressed in one of the default time zones.
<span id="L203" class="LineNr">203 </span>
<span id="L204" class="LineNr">204 </span>
<span id="L205" class="LineNr">205 </span>Syntax:
<span id="L206" class="LineNr">206 </span>declare date_time_$from_clock entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L207" class="LineNr">207 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L208" class="LineNr">208 </span>call date_time_$from_clock <span class="textRainbow_lv0_p0">(</span>clock<span class="textRainbow_lv0_o0">,</span> zone<span class="textRainbow_lv0_o0">,</span> addr<span class="textRainbow_lv1_p0">(</span>time_value<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L209" class="LineNr">209 </span>
<span id="L210" class="LineNr">210 </span>
<span id="L211" class="LineNr">211 </span>Arguments:
<span id="L212" class="LineNr">212 </span>clock
<span id="L213" class="LineNr">213 </span>   is the binary clock value to be decoded.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L214" class="LineNr">214 </span>zone
<span id="L215" class="LineNr">215 </span>   the short name of the zone in which output time value is expressed.
<span id="L216" class="LineNr">216 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> &quot;system_zone&quot; means use the system default zone.  &quot;&quot; means
<span id="L217" class="LineNr">217 </span>   use the per-process default zone.
<span id="L218" class="LineNr">218 </span>time_value
<span id="L219" class="LineNr">219 </span>   is the structure containing time parts.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L220" class="LineNr">220 </span>code
<span id="L221" class="LineNr">221 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L222" class="LineNr">222 </span>
<span id="L223" class="LineNr">223 </span>
<span id="L224" class="LineNr">224 </span>:Entry:  from_clock_interval:  1985-03-04 date_time_$from_clock_interval
<span id="L225" class="LineNr">225 </span>
<span id="L226" class="LineNr">226 </span>
<span id="L227" class="LineNr">227 </span>Function:  Given two clock values, return the number of years, months,
<span id="L228" class="LineNr">228 </span>weeks, days, hours, minutes, seconds, and microseconds between them.
<span id="L229" class="LineNr">229 </span>The set of units to use is specified, as well as whether any are to
<span id="L230" class="LineNr">230 </span>include the fractional remainder.
<span id="L231" class="LineNr">231 </span>
<span id="L232" class="LineNr">232 </span>
<span id="L233" class="LineNr">233 </span>Syntax:
<span id="L234" class="LineNr">234 </span>declare date_time_$from_clock_interval entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed
<span id="L235" class="LineNr">235 </span>     bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L236" class="LineNr">236 </span>call date_time_$from_clock_interval <span class="textRainbow_lv0_p0">(</span>clock1<span class="textRainbow_lv0_o0">,</span> clock2<span class="textRainbow_lv0_o0">,</span> addr
<span id="L237" class="LineNr">237 </span>     <span class="textRainbow_lv1_p0">(</span>time_offsets<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L238" class="LineNr">238 </span>
<span id="L239" class="LineNr">239 </span>
<span id="L240" class="LineNr">240 </span>Arguments:
<span id="L241" class="LineNr">241 </span>clock1
<span id="L242" class="LineNr">242 </span>   is the base time value.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The output is expressed relative to
<span id="L243" class="LineNr">243 </span>   this binary clock value.
<span id="L244" class="LineNr">244 </span>clock2
<span id="L245" class="LineNr">245 </span>   is the offset time value.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> clock1 is in essence subtracted
<span id="L246" class="LineNr">246 </span>   from this value.  If this value is later than clock1, all results
<span id="L247" class="LineNr">247 </span>   will be positive.  If this value is earlier, all results will be
<span id="L248" class="LineNr">248 </span>   negative.
<span id="L249" class="LineNr">249 </span>time_offsets
<span id="L250" class="LineNr">250 </span>   is the structure containing resulting time values.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> The
<span id="L251" class="LineNr">251 </span>   structure is defined in time_offset.incl.pl1
<span id="L252" class="LineNr">252 </span>code
<span id="L253" class="LineNr">253 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L254" class="LineNr">254 </span>
<span id="L255" class="LineNr">255 </span>
<span id="L256" class="LineNr">256 </span>:Entry:  fstime:  1985-03-04 date_time_$fstime
<span id="L257" class="LineNr">257 </span>
<span id="L258" class="LineNr">258 </span>
<span id="L259" class="LineNr">259 </span>Function:  This entry performs the same function as date_time_ given a
<span id="L260" class="LineNr">260 </span>36-bit storage system date value.
<span id="L261" class="LineNr">261 </span>
<span id="L262" class="LineNr">262 </span>
<span id="L263" class="LineNr">263 </span>Syntax:
<span id="L264" class="LineNr">264 </span>declare date_time_$fstime entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L265" class="LineNr">265 </span>call date_time_$fstime <span class="textRainbow_lv0_p0">(</span>ssclock<span class="textRainbow_lv0_o0">,</span> str<span class="textRainbow_lv0_p0">)</span>;
<span id="L266" class="LineNr">266 </span>
<span id="L267" class="LineNr">267 </span>
<span id="L268" class="LineNr">268 </span>Arguments:
<span id="L269" class="LineNr">269 </span>ssclock
<span id="L270" class="LineNr">270 </span>   is an internal storage system clock value.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L271" class="LineNr">271 </span>str
<span id="L272" class="LineNr">272 </span>   is the resultant character string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L273" class="LineNr">273 </span>
<span id="L274" class="LineNr">274 </span>
<span id="L275" class="LineNr">275 </span>:Entry:  offset_to_clock:  1985-03-04 date_time_$offset_to_clock
<span id="L276" class="LineNr">276 </span>
<span id="L277" class="LineNr">277 </span>
<span id="L278" class="LineNr">278 </span>Function:  This entry point creates a new Multics clock value by
<span id="L279" class="LineNr">279 </span>adjusting an input clock value to a specified day-of-week and then
<span id="L280" class="LineNr">280 </span>adding relative date/time offsets.  The relative date/time values
<span id="L281" class="LineNr">281 </span>include a year offset, month offset, week offset, day offset, hour
<span id="L282" class="LineNr">282 </span>offset, minute offset, second offset, and microsecond offset.  Any of
<span id="L283" class="LineNr">283 </span>these values may be zero <span class="textRainbow_lv0_p0">(</span>no offset from input clock value<span class="textRainbow_lv0_p0">)</span> or negative
<span id="L284" class="LineNr">284 </span><span class="textRainbow_lv0_p0">(</span>backwards offset from input clock value<span class="textRainbow_lv0_p0">)</span>.  In addition, an input time
<span id="L285" class="LineNr">285 </span>zone is specified.
<span id="L286" class="LineNr">286 </span>
<span id="L287" class="LineNr">287 </span>
<span id="L288" class="LineNr">288 </span>Syntax:
<span id="L289" class="LineNr">289 </span>declare date_time_$offset_to_clock entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L290" class="LineNr">290 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L291" class="LineNr">291 </span>call date_time_$offset_to_clock <span class="textRainbow_lv0_p0">(</span>addr<span class="textRainbow_lv1_p0">(</span>time_offset<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> clock_in<span class="textRainbow_lv0_o0">,</span> zone<span class="textRainbow_lv0_o0">,</span>
<span id="L292" class="LineNr">292 </span>     clock<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L293" class="LineNr">293 </span>
<span id="L294" class="LineNr">294 </span>
<span id="L295" class="LineNr">295 </span>Arguments:
<span id="L296" class="LineNr">296 </span>time_offset
<span id="L297" class="LineNr">297 </span>   is the structure containing time offsets to be applied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L298" class="LineNr">298 </span>   Structure is defined in time_offset.incl.pl1.
<span id="L299" class="LineNr">299 </span>clock_in
<span id="L300" class="LineNr">300 </span>   is the clock value to which offsets are applied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L301" class="LineNr">301 </span>zone
<span id="L302" class="LineNr">302 </span>   is the zone in which clock_in is to be interpreted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L303" class="LineNr">303 </span>clock
<span id="L304" class="LineNr">304 </span>   is the resulting clock value.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L305" class="LineNr">305 </span>code
<span id="L306" class="LineNr">306 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L307" class="LineNr">307 </span>
<span id="L308" class="LineNr">308 </span>
<span id="L309" class="LineNr">309 </span>:Entry:  set_lang:  1985-03-04 date_time_$set_lang
<span id="L310" class="LineNr">310 </span>
<span id="L311" class="LineNr">311 </span>
<span id="L312" class="LineNr">312 </span>Function:  This entry sets or resets the user's default time language.
<span id="L313" class="LineNr">313 </span>
<span id="L314" class="LineNr">314 </span>
<span id="L315" class="LineNr">315 </span>Syntax:
<span id="L316" class="LineNr">316 </span>declare date_time_$set_lang entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L317" class="LineNr">317 </span>call date_time_$set_lang <span class="textRainbow_lv0_p0">(</span>lang<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L318" class="LineNr">318 </span>
<span id="L319" class="LineNr">319 </span>
<span id="L320" class="LineNr">320 </span>Arguments:
<span id="L321" class="LineNr">321 </span>lang
<span id="L322" class="LineNr">322 </span>   the language which is to be made current.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> &quot;system_lang&quot;
<span id="L323" class="LineNr">323 </span>   means use the system default time language.
<span id="L324" class="LineNr">324 </span>code
<span id="L325" class="LineNr">325 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L326" class="LineNr">326 </span>
<span id="L327" class="LineNr">327 </span>
<span id="L328" class="LineNr">328 </span>:Entry:  set_zone:  1985-03-04 date_time_$set_zone
<span id="L329" class="LineNr">329 </span>
<span id="L330" class="LineNr">330 </span>
<span id="L331" class="LineNr">331 </span>Function:  This entry sets or resets the user's default zone.
<span id="L332" class="LineNr">332 </span>
<span id="L333" class="LineNr">333 </span>
<span id="L334" class="LineNr">334 </span>Syntax:
<span id="L335" class="LineNr">335 </span>declare date_time_$set_zone entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L336" class="LineNr">336 </span>call date_time_$set_zone <span class="textRainbow_lv0_p0">(</span>zone code<span class="textRainbow_lv0_p0">)</span>;
<span id="L337" class="LineNr">337 </span>
<span id="L338" class="LineNr">338 </span>
<span id="L339" class="LineNr">339 </span>Arguments:
<span id="L340" class="LineNr">340 </span>zone
<span id="L341" class="LineNr">341 </span>   the short name of the zone which is to be made current.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L342" class="LineNr">342 </span>   &quot;system_zone&quot; means use the system default zone.
<span id="L343" class="LineNr">343 </span>code
<span id="L344" class="LineNr">344 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L345" class="LineNr">345 </span>
<span id="L346" class="LineNr">346 </span>
<span id="L347" class="LineNr">347 </span>:Entry:  to_clock:  1985-03-04 date_time_$to_clock
<span id="L348" class="LineNr">348 </span>
<span id="L349" class="LineNr">349 </span>
<span id="L350" class="LineNr">350 </span>Function:  Given any or all of the following - years, months, days,
<span id="L351" class="LineNr">351 </span>hours, minutes, seconds, microseconds, day in week, day in year, or day
<span id="L352" class="LineNr">352 </span>in clock - returns a standard clock value which represents the encoding
<span id="L353" class="LineNr">353 </span>of these values.  All the values must be valid, i.e.  not greater than
<span id="L354" class="LineNr">354 </span>23, etc.
<span id="L355" class="LineNr">355 </span>
<span id="L356" class="LineNr">356 </span>
<span id="L357" class="LineNr">357 </span>Syntax:
<span id="L358" class="LineNr">358 </span>declare date_time_$to_clock entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L359" class="LineNr">359 </span>call date_time_$to_clock <span class="textRainbow_lv0_p0">(</span>addr <span class="textRainbow_lv1_p0">(</span>time_value<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> clock<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L360" class="LineNr">360 </span>
<span id="L361" class="LineNr">361 </span>
<span id="L362" class="LineNr">362 </span>Arguments:
<span id="L363" class="LineNr">363 </span>time_value
<span id="L364" class="LineNr">364 </span>   is the structure containing time parts.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The structure is
<span id="L365" class="LineNr">365 </span>   defined in time_value.incl.pl1.
<span id="L366" class="LineNr">366 </span>clock
<span id="L367" class="LineNr">367 </span>   is the encoded clock value.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L368" class="LineNr">368 </span>code
<span id="L369" class="LineNr">369 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L370" class="LineNr">370 </span>
<span id="L371" class="LineNr">371 </span>
<span id="L372" class="LineNr">372 </span>:Entry:  valid_format:  1985-03-04 date_time_$valid_format
<span id="L373" class="LineNr">373 </span>
<span id="L374" class="LineNr">374 </span>
<span id="L375" class="LineNr">375 </span>Function:  This entry checks the validity of a format string using
<span id="L376" class="LineNr">376 </span>precisely the same tests as date_time_$format.
<span id="L377" class="LineNr">377 </span>
<span id="L378" class="LineNr">378 </span>
<span id="L379" class="LineNr">379 </span>Syntax:
<span id="L380" class="LineNr">380 </span>declare date_time_$valid_format entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L381" class="LineNr">381 </span>   fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L382" class="LineNr">382 </span>call date_time_$valid_format <span class="textRainbow_lv0_p0">(</span>format<span class="textRainbow_lv0_o0">,</span> errloc<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L383" class="LineNr">383 </span>
<span id="L384" class="LineNr">384 </span>
<span id="L385" class="LineNr">385 </span>Arguments:
<span id="L386" class="LineNr">386 </span>format
<span id="L387" class="LineNr">387 </span>   either a keyword, or an ioa-like control string describing the
<span id="L388" class="LineNr">388 </span>   desired result in terms of literal characters and date/time
<span id="L389" class="LineNr">389 </span>   selectors.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> See the date_time_$format entry point for a
<span id="L390" class="LineNr">390 </span>   description of valid format strings.
<span id="L391" class="LineNr">391 </span>errloc
<span id="L392" class="LineNr">392 </span>   is the character index in the format string where the error
<span id="L393" class="LineNr">393 </span>   occurred.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> This is meaningful only if it and code are both
<span id="L394" class="LineNr">394 </span>   nonzero.
<span id="L395" class="LineNr">395 </span>code
<span id="L396" class="LineNr">396 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L397" class="LineNr">397 </span>
<span id="L398" class="LineNr">398 </span>
<span id="L399" class="LineNr">399 </span>:hcom:
<span id="L400" class="LineNr">400 </span>
<span id="L401" class="LineNr">401 </span>
<span id="L402" class="LineNr">402 </span>
<span id="L403" class="LineNr">403 </span>/****^  HISTORY COMMENTS:
<span id="L404" class="LineNr">404 </span>  1) change<span class="textRainbow_lv0_p0">(</span>2020-06-15<span class="textRainbow_lv0_o0">,</span>GDixon<span class="textRainbow_lv0_p0">)</span>, approve<span class="textRainbow_lv0_p0">(</span>2021-02-22<span class="textRainbow_lv0_o0">,</span>MCR10088<span class="textRainbow_lv0_p0">)</span>,
<span id="L405" class="LineNr">405 </span>     audit<span class="textRainbow_lv0_p0">(</span>2021-05-27<span class="textRainbow_lv0_o0">,</span>Swenson<span class="textRainbow_lv0_p0">)</span>, install<span class="textRainbow_lv0_p0">(</span>2021-05-27<span class="textRainbow_lv0_o0">,</span>MR12.6g-0056<span class="textRainbow_lv0_p0">)</span>:
<span id="L406" class="LineNr">406 </span>      A) Fix problem in header of date_time_ subroutine entrypoint.
<span id="L407" class="LineNr">407 </span>      B) Clarify contents of date_time_$format &quot;Notes on time format&quot;
<span id="L408" class="LineNr">408 </span>         section.
<span id="L409" class="LineNr">409 </span>                                                   END HISTORY COMMENTS */
<span id="L410" class="LineNr">410 </span>
<span id="L411" class="LineNr">411 </span>
<span id="L412" class="LineNr">412 </span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
